## \file
# \author 2012 Hsin-Yi Chen
import sys
from mazo import composite
from mazo import util

## \brief Standard Input/Output
class StandardIO(object):

    ## \brief receive data from STDIN
    def _recieve(self):
        return sys.stdin.read()

    ## \brief send data to STDOUT
    def _send(self, message):
        sys.stdout.write(message)

## \brief Abstract Class for doing processes.
class Worker(object):

    ## \brief To do all processes
    def do(self):
        util.call_function(self, 'prepare')
        util.call_function(self, 'do_prejob')
        self.do_job()
        util.call_function(self, 'do_postjob')

## \brief To create Worker class with composed classes
#  \param name str class name
#  \param jobs list Job kind of classes
#  \param features list classes
def worker(name, jobs, features=[], io=StandardIO):
    #@TODO: check jobs is excepted
    classes = [io] + list(jobs) + features
    classes.append(Worker)
    cls = composite.composite(name, *classes)
    return cls
